/*
hhxdmp.c Version 0.2.0  Hash print database in hex
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

void hhxdmp(hshhdr,tag)
hashfmt *hshhdr;
char *tag;
   {
   int eofsw,rdlen;
   unsigned int adr;
   off_t loc;
   unsigned char buf[32];
   hshhdr->reason = 0;
   loc = lseek(hshhdr->hndl,(off_t) 0,SEEK_SET);
   if (loc != (off_t) 0)
      {
      perror("hhxdmp: lseek err");
      hshhdr->reason = SYS_ERR + errno;
      return;
      } /* if lseek err */
   printf("hhxdmp: %s\n", tag);
   eofsw = 0;
   adr = 0;
   while (!eofsw)
      {
      rdlen = read(hshhdr->hndl,buf,16);
      if (!rdlen)
	 {
	 eofsw = 1;
         break;
	 } /* eof */
      if (rdlen < 0)
	 {
         perror("hhxdmp: read error");
         hshhdr->reason = SYS_ERR + errno;
         return;
	 } /* read err */
      hputhx(adr,rdlen,buf);
      adr += 16;
      } /* for each 16 bytes */
   } /* hhxdmp */
